
import java.math.BigDecimal;
import java.sql.*;

public class Dbs {
	private static Dbs instance = new Dbs();
	
	private String dbFilename="";
	private Connection cn = null;
	
		
	private Dbs() {	
	}
	
	public static Dbs getInstance() {
		return instance;
	}
	
	
	 public  boolean  openDB(String filename) {
		 cn = null;  
		 boolean ok=false;
	        try      {  
	            Class.forName("org.sqlite.JDBC");  
	            cn = DriverManager.getConnection("jdbc:sqlite:"+filename);	
	            ok=true;
	        } 
	        catch (Exception e)       {  
	        	System.out.println(e.toString());
	        	Basis.Error(e.toString(),"Fehler");
	            e.printStackTrace();  
	            cn = null;  
	        }
	       return ok;
	    }	
	 

	// aktueller Wert : 
	// select gen_id( seq, 0)  FROM RDB$DATABASE;
	
	   // holt eine neue Sequenznummer 
    public long getSequenz(String seqname) {
        String sql = "SELECT NEXT VALUE FOR " + seqname + " FROM RDB$DATABASE;";
		Statement st;
		long index=-1;
		try {
			st = cn.createStatement();
			ResultSet  rs = st.executeQuery(sql);
			if (rs==null) return -1;
			
	        while( rs.next() ) {
	        	index = Long.parseLong(rs.getString( 1 ) );
	        }	        
		} catch (SQLException e) {
			Basis.Error( e.toString() , "Fehler beim Lesen einer SQL-Anweisung");
		}
		 return index;
    }	// getSequenz

	public ResultSet executeQuery(String sql) {
		Statement st;
		try {
			st = cn.createStatement();
			return st.executeQuery( sql );
		} catch (SQLException e) {
			Basis.Error( e.toString() , "Fehler beim Lesen einer SQL-Anweisung");
		}
		 return null;
	}
	
	
	public void changeDBS(String sql) {
		Statement st;
		try {
			st = cn.createStatement();
			st.executeUpdate(sql);			
		} catch (SQLException e) {
			Basis.Error( e.toString() , "Fehler beim Lesen einer SQL-Anweisung");
		}
	}
	
	
	public void closeDB() {
		try {
	    	  if( cn != null ) {
			cn.close();
	    	  }
		} catch (SQLException e) {
      	  Basis.Error( e.toString() , "Fehler beim Schlieen der Datenbank");
		} 
	}  // closeDB
	
	
	/*
	public boolean openDB2(String dbFilename, String user, String passwd) {
		this.dbFilename = dbFilename;
	    String dbDrv = "org.firebirdsql.jdbc.FBDriver";
	    String dbUrl="jdbc:firebirdsql://localhost:3050/"+dbFilename;     
    
	   	    
	    // Connecting to employee.fdb on localhost using the type4 driver with UTF8:
	    // jdbc:firebirdsql://localhost/C:/database/employee.fdb?lc_ctype=UTF8
        // Firebird Embedded:
        // jdbc:firebirdsql:embedded:alias-or-path-to-db>

	        // Verbindung zur Datenbank
	      try {        
	          // Treiber INIT, Verbinden  und SQL-Statement auslsen
	    	  
	    	  org.firebirdsql.pool.FBWrappingDataSource dataSource =  new org.firebirdsql.pool.FBWrappingDataSource();
	    	  
	    	  dataSource.setDatabase ("localhost/3050:"+dbFilename);

	          dataSource.setLoginTimeout (10);
	          java.sql.Connection c = dataSource.getConnection ("sysdba", "masterkey");
	    	  
	          return true;
	        } catch( Exception ex ) {
	          Basis.Error( ex.toString() , "Fehler beim ffnen der Datenbank");
	        } finally {
	          try { 
	        	  // if( null != cn ) cn.close(); 
	          } 
	          catch( Exception ex ) {
	        	  Basis.Error( ex.toString() , "Fehler beim ffnen der Datenbank");
	          }
	        }	
	      return false;
	}  // openDB		
*/
	
}
