import javax.swing.*;

import java.awt.*;

// schalter
import java.awt.event.*;

// https://sqlite.org/foreignkeys.html

@SuppressWarnings("serial")
public class Main extends JFrame implements ActionListener {
	
		private String dbFilename="company.db";

		private JButton bnEmployee = new JButton( "Mitarbeiter" );
		private JButton bnDept = new JButton( "Abteilungen" );
		private JButton bnSQL = new JButton( "SQL-Abfrage" );
		
	  public Main() {
	        setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
	        setSize(670,200);
	        setLocation(400,10);
	        setGUI();
	        
	        setVisible(true);  // muss am Schluss kommen
	  }
	    
	  private void setGUI() {
	      this.getContentPane().setLayout( new BorderLayout() );	
	      setToolBar();
	  }
	  
	  private void setToolBar() {
		  JToolBar toolBar = new JToolBar();
		   JButton bnOpenDB = new JButton( "Datenbank ffnen" );
		   bnOpenDB.setFont( new Font("Arial", Font.BOLD,22));
		   bnOpenDB.addActionListener(this);
		   bnOpenDB.setActionCommand("OpenDB");		   
		   toolBar.add(bnOpenDB);
		   
		   bnEmployee.setFont( new Font("Arial", Font.BOLD,22));
		   bnEmployee.addActionListener(this);
		   bnEmployee.setActionCommand("Employee");
		   bnEmployee.setEnabled(false);
		   toolBar.add(bnEmployee);
		   
		   bnDept.setFont( new Font("Arial", Font.BOLD,22));
		   bnDept.addActionListener(this);
		   bnDept.setActionCommand("Dept");
		   bnDept.setEnabled(false);
		   toolBar.add(bnDept);
		   
		   bnSQL.setFont( new Font("Arial", Font.BOLD,22));
		   bnSQL.addActionListener(this);
		   bnSQL.setActionCommand("SQL");
		   bnSQL.setEnabled(false);
		   toolBar.add(bnSQL);
		   
		   add(toolBar, BorderLayout.NORTH);
	  }  // setToolBar

	@Override
	public void actionPerformed(ActionEvent e) {
		String cmd = e.getActionCommand();
		switch (cmd) {
		case "OpenDB": openDB();
				break;
		case "Employee": showEmployee();
			break;
		case "Dept": showDept();
		break;
		case "SQL": showSQL();
		break;
		default: Basis.Error("Fehlerhafte case-Anweisung in actionPerformed", "Main");
				break;
		}
	}  // actionPerformed
	
	
	private void openDB() {
		Dbs dbs = Dbs.getInstance();
		String path = (String) System.getProperties().get("user.dir") ;
		if (dbs.openDB(path+"\\"+dbFilename)) {
			bnEmployee.setEnabled(true);
			bnDept.setEnabled(true);
			bnSQL.setEnabled(true);
		}
	}
	
	private void showEmployee() {
		new WEmployee(this);		
	}
	private void showDept() {
		
	}
	
	private void showSQL() {
		new WSQL(this);		
	}

	public static void main(String[] args) {
		new Main();

	}
	
}
