
import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.ArrayList;

class WDialogEmployee extends JDialog  implements ActionListener{
    private JLabel label1= new JLabel("Vorname");
    private JLabel label2= new JLabel("Nachname");

    private JLabel label3= new JLabel("Monatsgehalt");
    private JLabel label4= new JLabel("Abteilung");

    private JTextField tFirstname= new JTextField();
    private JTextField tLastname= new JTextField();
    private JTextField tMonthlysalary= new JTextField();
    private JComboBox cbDept= new JComboBox();

    private ArrayList<ModelDept> dept_Items=null;
    
    boolean neu=false;

    public boolean retcode=false;  // gibt an, ob Ok oder Esc gedrckt wurde
    
    public ModelEmployee empl;
    
    

  public WDialogEmployee( JDialog parent, boolean neu, ModelEmployee empl) {
   super(parent);
   setModal(true);
   this.empl=empl;
   setTitle("Bearbeiten eines Datensatzes");
   setSize(400,350);
   dept_Items = Dbs_QueriesExecute.getItemsFromDept().getItems();
   
   setGUI(empl);
   setVisible(true);
  }

  private void setGUI(ModelEmployee empl) {
        this.getContentPane().setLayout( new GridBagLayout() );

        tFirstname.setText( empl.getFirstname() );
        tLastname.setText( empl.getLastname() );
        tMonthlysalary.setText( empl.getMonthlysalary().toString() );
        ModelDept[] depts = new ModelDept[dept_Items.size()];
        int selIndex=-1;
        for (int i=0; i<dept_Items.size(); i++) {
        	depts[i] = dept_Items.get(i);
        	if (dept_Items.get(i).getPindex()==empl.getDeptindex()) {
        		selIndex=i;
        	}
        }
        cbDept = new JComboBox(depts);
        cbDept.setSelectedIndex(selIndex);
        //cbDept.setText( Long.toString(empl.getDeptindex()) );

       label1.setFont( new Font("Arial", Font.BOLD,18)  );
       label2.setFont( new Font("Arial", Font.BOLD,18)  );
       label3.setFont( new Font("Arial", Font.BOLD,18)  );
       label4.setFont( new Font("Arial", Font.BOLD,18)  );

       tFirstname.setFont( new Font("Arial", Font.BOLD,18)  );
       tLastname.setFont( new Font("Arial", Font.BOLD,18)  );
       tMonthlysalary.setFont( new Font("Arial", Font.BOLD,18)  );
       cbDept.setFont( new Font("Arial", Font.BOLD,18)  );

      this.getContentPane().add(label1,
          new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0,
          GridBagConstraints.WEST, GridBagConstraints.NONE,
          new Insets(30,20,0,0), 0, 0));

      this.getContentPane().add(tFirstname,
           new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
            new Insets(30,40,0,20), 00, 0));
      // -------------------------------

      this.getContentPane().add(label2,
          new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.NONE,
            new Insets(30,20,0,0), 0, 0));

      this.getContentPane().add(tLastname,
           new GridBagConstraints(1, 1, 1, 1, 1.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
            new Insets(30,40,0,20), 00, 0));
      // -------------------------------

      this.getContentPane().add(label3,
          new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.NONE,
            new Insets(30,20,0,0), 0, 0));

      this.getContentPane().add(tMonthlysalary,
           new GridBagConstraints(1, 2, 1, 1, 1.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
            new Insets(30,40,0,20), 00, 0));
      // -------------------------------

      this.getContentPane().add(label4,
          new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.NONE,
            new Insets(30,20,0,0), 0, 0));

      this.getContentPane().add(cbDept,
           new GridBagConstraints(1, 3, 1, 1, 1.0, 0.0,
            GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
            new Insets(30,40,0,20), 00, 0));
      // -------------------------------

        JPanel pn = new JPanel();
        pn.setLayout( new FlowLayout() );


        JButton bnOk = new JButton("Ok");
        bnOk.setFont( new Font("Arial", Font.BOLD,18)  );
        bnOk.addActionListener(this);
        bnOk.setActionCommand("OK");
        pn.add( bnOk);

        JButton bnESC = new JButton("Abbruch");
        bnESC.setFont( new Font("Arial", Font.BOLD,18)  );
        bnESC.addActionListener(this);
        bnESC.setActionCommand("ESC");
        pn.add( bnESC);

        this.getContentPane().add(pn,   new GridBagConstraints(0, 4, 2, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(25,0,0,0), 0, 0));

  }  // setGUI
  
  
  @Override
	public void actionPerformed(ActionEvent e) {
		String cmd = e.getActionCommand();
		switch (cmd) {
		case "OK": bnOk_click();
				break;
		case "ESC":bnESC_click();
			break;
		default: Basis.Error("Fehlerhafte case-Anweisung in actionPerformed", "Main");
				break;
		}
	}  // actionPerformed   

  void bnESC_click() {
    setVisible(false);
    dispose();
  }

  void bnOk_click() {
	  // Plausi
	  if (tFirstname.getText().trim().length()==0) {
		  Basis.Error("Bitte geben Sie einen Vornamen ein", "Eingabe");
		  tFirstname.requestFocus();
		  return;
	  }
	  empl.setFirstname(tFirstname.getText().trim());
	  
	  if (tLastname.getText().trim().length()==0) {
		  Basis.Error("Bitte geben Sie einen Nachnamen ein", "Eingabe");
		  tLastname.requestFocus();
		  return;
	  }
	  empl.setLastname(tLastname.getText().trim());
	  
	  BigDecimal msal = new BigDecimal(tMonthlysalary.getText());
	  if(BigDecimal.ZERO.compareTo(msal) >= 0) {
		  Basis.Error("Bitte geben Sie ein positives Gehalt, >0 ein", "Eingabe");
		  tMonthlysalary.requestFocus();
		  return;
	  }
	  empl.setMonthlysalary(msal.setScale(2, RoundingMode.HALF_UP));
	  
	  
	  if (cbDept.getSelectedIndex()<0) {
		  Basis.Error("Bitte whlen Sie eine Abteilung aus", "Eingabe");
		  cbDept.requestFocus();
		  return;
	  }
	  ModelDept dept =  dept_Items.get(cbDept.getSelectedIndex());
	  empl.setDeptindex(dept.getPindex());
	  
	  retcode=true;
    // Speichern in lokale Variablen
    setVisible(false);
    dispose();
  }

   public String getFirstname() {
     return tFirstname.getText().trim();
   }

   public String getLastname() {
     return tLastname.getText().trim();
   }

   public BigDecimal getMontlysalary() {	   
     return  new BigDecimal(tMonthlysalary.getText()).setScale(2, RoundingMode.HALF_UP);
   }

   public long getDeptindex() {
     return 1; // Long.parseLong(cbDept.getText()); 
   }


}
